package com.expertandroid.plugin;

import com.intellij.openapi.application.ApplicationManager;
import com.intellij.openapi.components.ProjectComponent;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.vfs.*;
import org.jetbrains.annotations.NotNull;

import java.io.*;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

/**
 * Created by murat on 1/27/16.
 */
public class MyProjectComponent implements ProjectComponent {
    public MyProjectComponent(Project project) {
    }

    @Override
    public void initComponent() {
        // TODO: insert component initialization logic here

        VirtualFileManager.getInstance().addVirtualFileListener(listener);
    }

    @Override
    public void disposeComponent() {
        // TODO: insert component disposal logic here
        VirtualFileManager.getInstance().removeVirtualFileListener(listener);
    }

    @Override
    @NotNull
    public String getComponentName() {
        return "MyProjectComponent";
    }

    @Override
    public void projectOpened() {
        // called when project is opened
    }

    @Override
    public void projectClosed() {
        // called when project is being closed
    }

    VirtualFileListener listener= new VirtualFileListener() {
        @Override
        public void propertyChanged(@NotNull VirtualFilePropertyEvent virtualFilePropertyEvent) {

        }

        @Override
        public void contentsChanged(@NotNull VirtualFileEvent virtualFileEvent) {

//                ApplicationManager.getApplication().runReadAction(new Runnable() {
//                    @Override
//                    public void run() {
//                        try {
//                            InputStream is = virtualFileEvent.getFile().getInputStream();
//                            BufferedReader reader = new BufferedReader(new InputStreamReader(is));
//                            String line = null;
//                            String finalLine = "";
//                            while ((line = reader.readLine()) != null) {
//                                //concanate the lines
//                                finalLine += line + "\n";
//                            }
//                            //we are done with the input stream
//                            is.close();
//                            //convert chars
//                            String toOut = convertTr(finalLine);
//                            if (!toOut.equals(finalLine)) {
//                                write(virtualFileEvent, toOut);
//                            }
//                        } catch (IOException e) {
//                            e.printStackTrace();
//                        } finally {
//
//                        }
//                    }
//                });

        }

        private void write(VirtualFileEvent virtualFileEvent, String toOut){
            ApplicationManager.getApplication().runWriteAction (new Runnable() {
                @Override
                public void run() {
                    try {
                        virtualFileEvent.getFile().setBinaryContent(toOut.getBytes());
                    } catch (IOException e) {
                        e.printStackTrace();
                    } finally {

                    }
                }
            });
        }

        private String convertTr(String nativeText) {
            Map charMap = new HashMap<>();
            charMap.put("s", "\\\\u00e7");
            charMap.put("ç", "\\\\u00e7");
            charMap.put("Ç", "\\\\u00c7");
            charMap.put("ğ", "\\\\u011f");
            charMap.put("Ğ", "\\\\u011e");
            charMap.put("ş", "\\\\u015f");
            charMap.put("Ş", "\\\\u015e");
            charMap.put("ı", "\\\\u0131");
            charMap.put("İ", "\\\\u0130");
            charMap.put("ö", "\\\\u00f6");
            charMap.put("Ö", "\\\\u00d6");
            charMap.put("ü", "\\\\u00fc");
            charMap.put("Ü", "\\\\u00dc");
            String asciiText = "";
            if (nativeText != null) {
                asciiText = new String(nativeText);
                Set keySet = charMap.keySet();
                Iterator it = keySet.iterator();
                while (it.hasNext()) {
                    String nativeChar = (String) it.next();
                    String asciiChar = (String) charMap.get(nativeChar);
                    asciiText = asciiText.replaceAll(nativeChar, asciiChar);
                }
            }
            return asciiText;
        }

        @Override
        public void fileCreated(@NotNull VirtualFileEvent virtualFileEvent) {

        }

        @Override
        public void fileDeleted(@NotNull VirtualFileEvent virtualFileEvent) {

        }

        @Override
        public void fileMoved(@NotNull VirtualFileMoveEvent virtualFileMoveEvent) {

        }

        @Override
        public void fileCopied(@NotNull VirtualFileCopyEvent virtualFileCopyEvent) {

        }

        @Override
        public void beforePropertyChange(@NotNull VirtualFilePropertyEvent virtualFilePropertyEvent) {

        }

        @Override
        public void beforeContentsChange(@NotNull VirtualFileEvent virtualFileEvent) {

        }

        @Override
        public void beforeFileDeletion(@NotNull VirtualFileEvent virtualFileEvent) {

        }

        @Override
        public void beforeFileMovement(@NotNull VirtualFileMoveEvent virtualFileMoveEvent) {

        }
    };

}
